From 2d40845a49d46571056ba030b096529df54d3a6c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 19 2020 00:24:16 +0000
Subject: [PATCH 182/2232] Eliminate use of transmute in Result::exception


---

diff --git a/src/result.rs b/src/result.rs
index 047260b..296efea 100644
--- a/src/result.rs
+++ b/src/result.rs
@@ -1,7 +1,6 @@
 use crate::exception::Exception;
 use crate::rust_str::RustStr;
 use std::fmt::Display;
-use std::mem;
 use std::ptr;
 use std::result::Result as StdResult;
 use std::slice;
@@ -50,10 +49,10 @@ impl Result {
             Ok(())
         } else {
             let err = self.err;
-            let slice = slice::from_raw_parts(err.ptr.as_ptr(), err.len);
-            let s = str::from_utf8_unchecked(slice);
+            let slice = slice::from_raw_parts_mut(err.ptr.as_ptr(), err.len);
+            let s = str::from_utf8_unchecked_mut(slice);
             Err(Exception {
-                what: mem::transmute::<*const str, Box<str>>(s),
+                what: Box::from_raw(s),
             })
         }
     }

